"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var http_1 = require('@angular/http');
require('rxjs/add/operator/map');
var env_1 = require('../../../dist/env');
/*
  Generated class for the storessService provider.

  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
  for more info on providers and Angular 2 DI.
*/
var StoreProvider = (function () {
    function StoreProvider(http) {
        this.http = http;
    }
    StoreProvider.prototype.load = function () {
        var _this = this;
        if (this.stores) {
            // already loaded data
            return Promise.resolve(this.stores);
        }
        // don't have the data yet
        return new Promise(function (resolve) {
            // We're using Angular Http provider to request the data,
            // then on the response it'll map the JSON data to a parsed JS object.
            // Next we process the data and resolve the promise with the new data.
            var store = JSON.parse(localStorage.getItem('logged')).store;
            _this.http.get(env_1.currentProvider + "stores")
                .map(function (res) { return res.json(); })
                .subscribe(function (data) {
                // we've got back the raw data, now generate the core schedule data
                // and save the data for later reference
                _this.stores = data;
                resolve(_this.stores);
            }, function (err) {
                console.error('Error fetching stores from API\n', err);
            });
        });
    };
    StoreProvider = __decorate([
        core_1.Injectable(), 
        __metadata('design:paramtypes', [http_1.Http])
    ], StoreProvider);
    return StoreProvider;
}());
exports.StoreProvider = StoreProvider;
//# sourceMappingURL=store.provider.js.map