import { Injectable } from '@angular/core';
import { Http } from '@angular/http';
import 'rxjs/add/operator/map';

import { currentProvider } from '../../../dist/env';

/*
  Generated class for the storessService provider.

  See https://angular.io/docs/ts/latest/guide/dependency-injection.html
  for more info on providers and Angular 2 DI.
*/
@Injectable()
export class StoreProvider {
  stores: any;

  constructor(private http: Http) {}
  load() {
    if (this.stores) {
      // already loaded data
      return Promise.resolve(this.stores);
    }

    // don't have the data yet
    return new Promise(resolve => {
      // We're using Angular Http provider to request the data,
      // then on the response it'll map the JSON data to a parsed JS object.
      // Next we process the data and resolve the promise with the new data.
      let store = JSON.parse(localStorage.getItem('logged')).store;
      this.http.get(`${currentProvider}stores`)
        .map(res => res.json())
        .subscribe(data => {
          // we've got back the raw data, now generate the core schedule data
          // and save the data for later reference

          this.stores = data;
          resolve(this.stores);
        }, (err) => {
          console.error('Error fetching stores from API\n', err);
        });
    });
  }

}
